# ---------------------------------------------------------------------------------
#  /\_/\  🌐 This module was loaded through https://t.me/hikkamods_bot
# ( o.o )  🔐 Licensed under the GNU GPLv3.
#  > ^ <   ⚠️ Owner of heta.hikariatama.ru doesn't take any responsibilities or intellectual property rights regarding this script
# ---------------------------------------------------------------------------------
# Name: typer
# Description: Makes your messages type slower
# Author: HitaloSama
# Commands:
# .type
# ---------------------------------------------------------------------------------


#    Friendly Telegram (telegram userbot)
#    Copyright (C) 2018-2019 The Authors

#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.

#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <https://www.gnu.org/licenses/>.

import asyncio
import logging

from telethon.errors.rpcerrorlist import MessageNotModifiedError

from .. import loader, utils

logger = logging.getLogger(__name__)


@loader.tds
class TyperMod(loader.Module):
    """Makes your messages type slower"""

    strings = {
        "name": "Typewriter",
        "no_message": "<b>You can't type nothing!</b>",
        "type_char_cfg_doc": "Character for typewriter",
        "delay_typer_cfg_doc": "How long to delay showing the typewriter character",
        "delay_text_cfg_doc": "How long to delay showing the text",
    }

    def __init__(self):
        self.config = loader.ModuleConfig(
            "TYPE_CHAR",
            "▒",
            lambda m: self.strings("type_char_cfg_doc", m),
            "DELAY_TYPER",
            0.04,
            lambda m: self.strings("delay_typer_cfg_doc", m),
            "DELAY_TEXT",
            0.02,
            lambda m: self.strings("delay_text_cfg_doc", m),
        )

    @loader.ratelimit
    async def typecmd(self, message):
        """.type <message>"""
        a = utils.get_args_raw(message)
        if not a:
            await utils.answer(message, self.strings("no_message", message))
            return
        m = ""
        entities = message.entities or []
        for c in a:
            m += self.config["TYPE_CHAR"]
            message = await update_message(message, m, entities)
            await asyncio.sleep(0.04)
            m = m[:-1] + c
            message = await update_message(message, m, entities)
            await asyncio.sleep(0.02)


async def update_message(message, m, entities):
    try:
        return await utils.answer(message, m, parse_mode=lambda t: (t, entities))
    except MessageNotModifiedError:
        return message  # space doesnt count
